#
# Copyright (c) 2021 Nitric Technologies Pty Ltd.
#
# This file is part of Nitric Python 3 SDK.
# See https://github.com/nitrictech/python-sdk for further info.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from nitric.proto.storage.v1 import storage_pb2 as storage_dot_v1_dot_storage__pb2


class StorageStub(object):
    """Services for storage and retrieval of files in the form of byte arrays, such as text and binary files.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Read = channel.unary_unary(
                '/nitric.storage.v1.Storage/Read',
                request_serializer=storage_dot_v1_dot_storage__pb2.StorageReadRequest.SerializeToString,
                response_deserializer=storage_dot_v1_dot_storage__pb2.StorageReadResponse.FromString,
                )
        self.Write = channel.unary_unary(
                '/nitric.storage.v1.Storage/Write',
                request_serializer=storage_dot_v1_dot_storage__pb2.StorageWriteRequest.SerializeToString,
                response_deserializer=storage_dot_v1_dot_storage__pb2.StorageWriteResponse.FromString,
                )
        self.Delete = channel.unary_unary(
                '/nitric.storage.v1.Storage/Delete',
                request_serializer=storage_dot_v1_dot_storage__pb2.StorageDeleteRequest.SerializeToString,
                response_deserializer=storage_dot_v1_dot_storage__pb2.StorageDeleteResponse.FromString,
                )


class StorageServicer(object):
    """Services for storage and retrieval of files in the form of byte arrays, such as text and binary files.
    """

    def Read(self, request, context):
        """Retrieve an item from a bucket
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Write(self, request, context):
        """Store an item to a bucket
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Delete(self, request, context):
        """Delete an item from a bucket
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_StorageServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'Read': grpc.unary_unary_rpc_method_handler(
                    servicer.Read,
                    request_deserializer=storage_dot_v1_dot_storage__pb2.StorageReadRequest.FromString,
                    response_serializer=storage_dot_v1_dot_storage__pb2.StorageReadResponse.SerializeToString,
            ),
            'Write': grpc.unary_unary_rpc_method_handler(
                    servicer.Write,
                    request_deserializer=storage_dot_v1_dot_storage__pb2.StorageWriteRequest.FromString,
                    response_serializer=storage_dot_v1_dot_storage__pb2.StorageWriteResponse.SerializeToString,
            ),
            'Delete': grpc.unary_unary_rpc_method_handler(
                    servicer.Delete,
                    request_deserializer=storage_dot_v1_dot_storage__pb2.StorageDeleteRequest.FromString,
                    response_serializer=storage_dot_v1_dot_storage__pb2.StorageDeleteResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'nitric.storage.v1.Storage', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class Storage(object):
    """Services for storage and retrieval of files in the form of byte arrays, such as text and binary files.
    """

    @staticmethod
    def Read(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/nitric.storage.v1.Storage/Read',
            storage_dot_v1_dot_storage__pb2.StorageReadRequest.SerializeToString,
            storage_dot_v1_dot_storage__pb2.StorageReadResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Write(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/nitric.storage.v1.Storage/Write',
            storage_dot_v1_dot_storage__pb2.StorageWriteRequest.SerializeToString,
            storage_dot_v1_dot_storage__pb2.StorageWriteResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Delete(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/nitric.storage.v1.Storage/Delete',
            storage_dot_v1_dot_storage__pb2.StorageDeleteRequest.SerializeToString,
            storage_dot_v1_dot_storage__pb2.StorageDeleteResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
